#include-once
;******************************************************************************
;***            EzBmpButton
;***                  by Greenhorn
;***
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>

Global $gdi32dll		=	DllOpen ("gdi32.dll")
Global $user32dll		=	DllOpen ("user32.dll")
Global $shell32dll		=	DllOpen ("shell32.dll")
Global $kernel32dll		=	DllOpen ("kernel32.dll")
Global $msimg32dll		=	DllOpen ("msimg32.dll")
Global $uxthemedll		=	DllOpen ("uxtheme.dll")
;~~~~~~~~~~~~~~~~~~~~~~  Structures  ~~~~~~~~~~~~~~~~~~~~~~

; --- $CREATESTRUCT
Global Const $CREATESTRUCT = _
	"ptr     lpCreateParams;"& _
	"HANDLE  hInstance;"& _
	"HANDLE  hMenu;"& _
	"HWND    hwndParent;"& _
	"int     cy;"& _
	"int     cx;"& _
	"int     y;"& _
	"int     x;"& _
	"LONG    style;"& _
	"ptr     lpszName;"& _
	"ptr     lpszClass;"& _
	"DWORD   dwExStyle;"


Global Const $WNDCLASSEX = _
	"UINT cbSize;" & _
	"UINT style;" & _
	"ptr  lpfnWndProc;" & _
	"int  cbClsExtra;" & _
	"int  cbWndExtra;" & _
	"ptr  hInstance;" & _
	"ptr  hIcon;" & _
	"ptr  hCursor;" & _
	"ptr  hbrBackground;" & _
	"ptr  lpszMenuName;" & _
	"ptr  lpszClassName;" & _
	"ptr  hIconSm;"
;
Global Const $POINT = _
	"LONG  x;" & _
	"LONG  y;"
;
Global Const $RECT = _
	"LONG  left;" & _
	"LONG  top;" & _
	"LONG  right;" & _
	"LONG  bottom;"
;
Global Const $SIZE = _
    'LONG  cx;'& _
    'LONG  cy;'

Global Const $PAINTSTRUCT = _
	"HANDLE  hDC;" & _
	"int     fErase;" & _
	"LONG    rcPaint[4];" & _
	"int     fRestore;" & _
	"int     fIncUpdate;" & _
	"BYTE    rgbReserved[32]"


; --- $TRACKMOUSEEVENT
Global Const $TRACKMOUSEEVENT = _
	'DWORD  cbSize;'& _
	'DWORD  dwFlags;'& _
	'HWND   hwndTrack;'& _
	'DWORD  dwHoverTime;'

; --- $NMHDR
Global Const $NMHDR = _
	'HWND      hwndFrom;'& _
	'UINT_PTR  idFrom;'& _
	'UINT      code;'

; --- $NMBCHOTITEM
Global Const $NMBCHOTITEM = _
	$NMHDR& _
	'DWORD dwFlags;'

; --- $BITMAP
Global Const $BITMAP = _
	'LONG    bmType;'& _
	'LONG    bmWidth;'& _
	'LONG    bmHeight;'& _
	'LONG    bmWidthBytes;'& _
	'USHORT  bmPlanes;'& _
	'USHORT  bmBitsPixel;'& _
	'ptr     bmBits;'

Global Const $MSG = _
	"HWND hwnd;" & _
	"UINT message;" & _
	"WPARAM wParam;" & _
	"LPARAM lParam;" & _
	"DWORD time;" & _
	$POINT


;	Custom Control state structure:
Global Const $BUTTONCTRL = _
	"HANDLE   hBmpNormal;"& _   ; bitmap in normal state
	"HANDLE   hBmpHover;"& _    ; bitmap in mouse hovering state
	"HANDLE   hBmpPress;"& _    ; bitmap in mouse pressed state
	"HANDLE   hBmpCurrent;"& _  ; bitmap to display currently
	"HWND     hWndCtrl;"& _     ; The control's window handle
	"HANDLE   hFont;"& _        ; The font
	"HANDLE   hTheme;"& _       ; The Theme handle
	"DWORD    crText;"& _       ; text color
	"UINT     uID;"& _          ; The button's identifier
	"int      iState;"& _       ; The state of the control
	"int      bPrefix;"& _      ; The state of the control
	"WCHAR    szText [128];"    ; Text of the control (max. 127 characters)


;~~~~~~~~~~~~~~~~~~~~~~  Constants  ~~~~~~~~~~~~~~~~~~~~~~


Global Const $_NULL = Ptr (0)

;~ Global Const $WM_LBUTTONDOWN = 0x0201
;~ Global Const $WM_MOUSEHOVER  = 0x02A1
;~ Global Const $WM_MOUSELEAVE  = 0x02A3
;~ Global Const $WM_THEMECHANGED = 794

Global Const $_CS_VREDRAW = 0x0001
Global Const $_CS_HREDRAW = 0x0002

Global Const $_IDI_APPLICATION = 32512
Global Const $_IDC_ARROW = MAKEINTRESOURCE (32512)

Global Const $_WHITE_BRUSH         = 0
Global Const $_LTGRAY_BRUSH        = 1
Global Const $_GRAY_BRUSH          = 2
Global Const $_DKGRAY_BRUSH        = 3
Global Const $_BLACK_BRUSH         = 4
Global Const $_NULL_BRUSH          = 5
Global Const $_HOLLOW_BRUSH        = 5
Global Const $_WHITE_PEN           = 6
Global Const $_BLACK_PEN           = 7
Global Const $_NULL_PEN            = 8
Global Const $_SYSTEM_FONT         = 13
Global Const $_DEFAULT_PALETTE     = 15
Global Const $_ANSI_FIXED_FONT     = 11
Global Const $_ANSI_VAR_FONT       = 12
Global Const $_DEVICE_DEFAULT_FONT = 14
Global Const $_DEFAULT_GUI_FONT    = 17
Global Const $_OEM_FIXED_FONT      = 10
Global Const $_SYSTEM_FIXED_FONT   = 16

Global Const $_ETO_OPAQUE = 0x0002

Global Const $_TME_HOVER	= 1
Global Const $_TME_LEAVE	= 2
Global Const $_TME_QUERY	= 0x40000000
Global Const $_TME_CANCEL	= 0x80000000
Global Const $_HOVER_DEFAULT	= 0xFFFFFFFF

Global Const $_VK_MENU	= 18
Global Const $_VK_RETURN	= 13
Global Const $_VK_SPACE	= 32
Global Const $_VK_TAB	= 9

Global Const $_IMAGE_BITMAP = 0
Global Const $_IMAGE_ICON	= 1
Global Const $_IMAGE_CURSOR	= 2
Global Const $_IMAGE_ENHMETAFILE	= 3

Global Const $_LR_DEFAULTCOLOR = 0
Global Const $_LR_MONOCHROME = 1
Global Const $_LR_COLOR = 2
Global Const $_LR_COPYRETURNORG = 4
Global Const $_LR_COPYDELETEORG = 8
Global Const $_LR_LOADFROMFILE = 16
Global Const $_LR_LOADTRANSPARENT = 32
Global Const $_LR_LOADREALSIZE = 128
Global Const $_LR_DEFAULTSIZE = 0x0040
Global Const $_LR_VGACOLOR = 0x0080
Global Const $_LR_LOADMAP3DCOLORS = 4096
Global Const $_LR_CREATEDIBSECTION = 8192
Global Const $_LR_COPYFROMRESOURCE = 0x4000
Global Const $_LR_SHARED = 32768

Global Const $_BM_CLICK = 245
Global Const $_BM_GETCHECK = 240
Global Const $_BM_GETIMAGE = 246
Global Const $_BM_GETSTATE = 242
Global Const $_BM_SETCHECK = 241
Global Const $_BM_SETIMAGE = 247
Global Const $_BM_SETSTATE = 243
Global Const $_BM_SETSTYLE = 244
Global Const $_BN_CLICKED = 0
Global Const $_BN_DBLCLK = 5
Global Const $_BN_DISABLE = 4
Global Const $_BN_DOUBLECLICKED = 5
Global Const $_BN_HILITE = 2
Global Const $_BN_KILLFOCUS = 7
Global Const $_BN_PAINT = 1
Global Const $_BN_PUSHED = 2
Global Const $_BN_SETFOCUS = 6
Global Const $_BN_UNHILITE = 3
Global Const $_BN_UNPUSHED = 3

Global Const $_DLGC_WANTARROWS     = 0x0001      ;* Control wants arrow keys         *;
Global Const $_DLGC_WANTTAB        = 0x0002      ;* Control wants tab keys           *;
Global Const $_DLGC_WANTALLKEYS    = 0x0004      ;* Control wants all keys           *;
Global Const $_DLGC_WANTMESSAGE    = 0x0004      ;* Pass message to control          *;
Global Const $_DLGC_HASSETSEL      = 0x0008      ;* Understands EM_SETSEL message    *;
Global Const $_DLGC_DEFPUSHBUTTON  = 0x0010      ;* Default pushbutton               *;
Global Const $_DLGC_UNDEFPUSHBUTTON = 0x0020     ;* Non-default pushbutton           *;
Global Const $_DLGC_RADIOBUTTON    = 0x0040      ;* Radio button                     *;
Global Const $_DLGC_WANTCHARS      = 0x0080      ;* Want WM_CHAR messages            *;
Global Const $_DLGC_STATIC         = 0x0100      ;* Static item: don't include       *;
Global Const $_DLGC_BUTTON         = 0x2000      ;* Button item: can be checked      *;

Global Enum $PBS_NORMAL = 1, _
	$PBS_HOT, _
	$PBS_PRESSED, _
	$PBS_DISABLED, _
	$PBS_DEFAULTED, _
	$PBS_DEFAULTED_ANIMATING

Global Const $BP_PUSHBUTTON = 1



;


Global Const $g_sBtnClassName = "EzBmpButton32"

Global $g_hInst
Global $g_hdcMem

Global $g_aButtonInfo [1] = [$_NULL]

Global $g_hButtonProc

Global $g_bMouseHover = FALSE
Global $g_bAccel      = FALSE
Global $g_bSysKeyDown = FALSE

;
; Initialize EzBmpButton at script start
;
InitEzButtonClass ( )


Func CreateEzBmpButton ($sTitle, $left, $top, $width, $height, $hWndParent, $bmpDefault, $bmpHover, $bmpPress, $crText = 0)

	Local $hwnd
	Local $lpBitmaps
	Local $stBitmaps


	; Check parameters
	If (not IsHWND ($hwndParent)) Then _
		Return 0


	; A dirty solution, I think, but it works ...
	$ctrlID = GUICtrlCreateDummy ( )

	; We could also load here the bitmaps and just put the
	; Handles into the structure, but I prefer to load them
	; at window creation. So we just put the path or resource ID
	; into the structure and set a pointer to this structure
	; at the lpParam to get the information back in the window's procedure.

	If ( IsInt ($bmpDefault) Or _
		IsInt ($bmpHover) Or _
		IsInt ($bmpPress)) Then

		$stBitmaps = DllStructCreate ( _
						"int  bmpDefault;"& _
						"int  bmpHover;"& _
						"int  bmpPress;"& _
						"DWORD colTxt" _
						)
	Else
		$stBitmaps = DllStructCreate ( _
						"WCHAR  bmpDefault [260];"& _
						"WCHAR  bmpHover   [260];"& _
						"WCHAR  bmpPress   [260];"& _
						"DWORD colTxt" _
						)
	EndIf

	DllStructSetData ($stBitmaps, "bmpDefault", $bmpDefault)
	DllStructSetData ($stBitmaps, "bmpHover"  , $bmpHover)
	DllStructSetData ($stBitmaps, "bmpPress"  , $bmpPress)
	DllStructSetData ($stBitmaps, "colTxt"    , $crText)

	$lpBitmaps = DllStructGetPtr ($stBitmaps)

	$hwnd = CreateWindowEx ( _
				0, _
				$g_sBtnClassName, _
				$sTitle, _
				BitOR ($WS_CHILD, $WS_VISIBLE, $WS_TABSTOP, $WS_CLIPSIBLINGS), _
				$left, $top, $width, $height, _
				$hWndParent, _
				$ctrlID, _
				$g_hInst, _
				$lpBitmaps _
				)

	Return $ctrlID

EndFunc

Func InitEzButtonClass ( )

	Local $szBtnClassName, $wcx, $lpwcx, $nSize

	If (@AutoItX64 == 1) Then
		$nSize = 8
	Else
		$nSize = 4
	EndIf

	OnAutoItExitRegister ("OnEzBmpButtonExit")

	$g_hInst = GetModuleHandle ($_NULL)

	$g_hdcMem = CreateCompatibleDC ($_NULL)

	$g_hButtonProc = DllCallbackRegister ("EzBmpButtonProc", "LRESULT", "HWND;UINT;WPARAM;LPARAM")

	$szBtnClassName = DllStructCreate ("wchar szBtnClassName ["&StringLen ($g_sBtnClassName) + 1&"]")
	DllStructSetData ($szBtnClassName, "szBtnClassName", $g_sBtnClassName)

	$wcx = DllStructCreate ($WNDCLASSEX)

	DllStructSetData ($wcx,"cbSize",        DllStructGetSize ($wcx))
	DllStructSetData ($wcx,"style",         0);BitOR ($_CS_HREDRAW, $_CS_VREDRAW))
	DllStructSetData ($wcx,"lpfnWndProc",   DllCallbackGetPtr ($g_hButtonProc))
	DllStructSetData ($wcx,"cbClsExtra",    0)
	DllStructSetData ($wcx,"cbWndExtra",    $nSize)   ; here we store the pointer to the ButtonCtrl structure.
	DllStructSetData ($wcx,"hInstance",     $g_hInst)
	DllStructSetData ($wcx,"hIcon",         $_NULL)
	DllStructSetData ($wcx,"hCursor",       LoadCursor ($_NULL, $_IDC_ARROW))
	DllStructSetData ($wcx,"hbrBackground", $_NULL)
	DllStructSetData ($wcx,"lpszMenuName",  $_NULL)
	DllStructSetData ($wcx,"lpszClassName", DllStructGetPtr ($szBtnClassName))
	DllStructSetData ($wcx,"hIconSm",       $_NULL)

	$lpwcx = DllStructGetPtr ($wcx)

	If Not RegisterClassEx ($lpwcx) Then
		MsgBox (266256, "Fehler!", "Die Fensterklasse konnte nicht registriert werden!")
		Exit (1)
	EndIf

EndFunc

Func EzBmpButtonProc ($hWnd, $message, $wParam, $lParam)

	; Get the pointer to the button structure
	; for THIS window.
	Local $lpButton = GetWindowLongPtr ($hWnd, 0)

	Switch ($message)

		Case $WM_NCCREATE
			OnCreate ($hWnd, $lParam)
			Return 1

		Case $WM_PAINT
			OnPaint ($lpButton)

		Case $WM_GETDLGCODE
			OnGetDlgCode ($lpButton, $lParam)

		Case $WM_KEYUP
			OnKeyUp ($lpButton, $wParam)

		Case $WM_LBUTTONDOWN
			OnLButtonDown ($lpButton)

		Case $WM_LBUTTONUP
			OnLButtonUp ($lpButton)

		Case $WM_MOUSELEAVE
			OnMouseLeave ($lpButton)

		Case $WM_MOUSEMOVE
			OnMouseMove ($lpButton)

		Case $WM_MOUSEHOVER
			OnMouseHover ($lpButton)

		Case $WM_GETFONT
			Return OnGetFont ($lpButton)

		Case $WM_SETFONT
			OnSetFont ($lpButton, $wParam)

		Case $WM_SETFOCUS
			OnSetFocus ($lpButton)

		Case $WM_KILLFOCUS
			OnKillFocus ($lpButton)

		Case $WM_THEMECHANGED
			OnKillFocus ($lpButton)

		Case $WM_SYSKEYDOWN
			OnSysKeyDown ($lpButton)

		Case $WM_SYSKEYUP
			OnSysKeyUp ($lpButton)

		Case $WM_NCDESTROY
			OnDestroy ($lpButton)
			ContinueCase
		Case Else
			Return DefWindowProc ($hWnd, $message, $wParam, $lParam)
	EndSwitch

	Return 0

EndFunc

Func LoadButtonBitmaps (ByRef $stButtonInfo, $lpCreateParams)

	Local $stCreateParams
	Local $asBmp [3]
	Local $hBmp

	If (Not $lpCreateParams) Then _
		Return False

	$stCreateParams = DllStructCreate ("WCHAR  bmpDefault [260];"& _
							     "WCHAR  bmpHover   [260];"& _
							     "WCHAR  bmpPress   [260];"& _
							     "DWORD colTxt", _
							     $lpCreateParams)

	; first set the text color.
	DllStructSetData ($stButtonInfo, "crText", _
			DllStructGetData ($stCreateParams, "colTxt"))

	$asBmp[0] = DllStructGetData ($stCreateParams, "bmpDefault")
	$asBmp[1] = DllStructGetData ($stCreateParams, "bmpHover")
	$asBmp[2] = DllStructGetData ($stCreateParams, "bmpPress")

	$fuLoad = BitOR ($_LR_DEFAULTSIZE, $_LR_CREATEDIBSECTION, $_LR_VGACOLOR)

	For $i = 0 To 2

		If (IsInt ($asBmp[$i])) Then

			$hBmp = LoadImage ($g_hInst, MAKEINTRESOURCE($asBmp[$i]), $_IMAGE_BITMAP, _
							0, 0, $fuLoad)

			DllStructSetData ($stButtonInfo, $i + 1, $hBmp)

		ElseIf (Not FileExists ($asBmp[$i])) Then

			$hBmp = LoadImage ($g_hInst, $asBmp[$i], $_IMAGE_BITMAP, _
							0, 0, $fuLoad)

			DllStructSetData ($stButtonInfo, $i + 1, $hBmp)
		Else

			$hBmp = LoadImage ($_NULL, $asBmp[$i], $_IMAGE_BITMAP, _
							0, 0, BitOR ($fuLoad, $_LR_LOADFROMFILE))

			DllStructSetData ($stButtonInfo, $i + 1, $hBmp)
		EndIf

		If (Not $hBmp) Then _
			Return False

	Next

	DllStructSetData ($stButtonInfo, "hBmpCurrent", _
			DllStructGetData ($stButtonInfo, "hBmpNormal"))

	Return True

EndFunc

Func NotifyParent ($lpBtnInfo, $uCode)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $nmh     = DllStructCreate ($NMHDR)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	DllStructSetData ($nmh, "code"    , $uCode)
	DllStructSetData ($nmh, "idFrom"  , GetDlgCtrlID ($hwndCtrl))
	DllStructSetData ($nmh, "hwndFrom", $hwndCtrl)

	SendMessage (GetParent ($hwndCtrl), _
				 $WM_NOTIFY, _
				 GetDlgCtrlID ($hwndCtrl), _
				 DllStructGetPtr ($nmh))

EndFunc

Func OnCreate ($hWnd, $lParam)

	Local $cs
	Local $iSize = 0
	Local $hTheme


	$cs = DllStructCreate ($CREATESTRUCT, $lParam)

	$iSize = UBound ($g_aButtonInfo)

	If (IsDllStruct ($g_aButtonInfo[0])) Then

		ReDim $g_aButtonInfo [$iSize + 1]
		$iSize += 1
	EndIf

	$g_aButtonInfo[$iSize - 1] = DllStructCreate ($BUTTONCTRL)

	If ($g_aButtonInfo[$iSize - 1] == 0) Then _
		Return False

	DllStructSetData ($g_aButtonInfo[$iSize - 1], "hWndCtrl" , $hWnd)
	DllStructSetData ($g_aButtonInfo[$iSize - 1], "hFont", GetStockObject ($_DEFAULT_GUI_FONT))


	; Load the bitmaps for the window
	If (not LoadButtonBitmaps ($g_aButtonInfo[$iSize - 1], _
						  DllStructGetData ($cs, "lpCreateParams"))) Then

		If (IsAppThemed ( )) Then
			DllStructSetData ($g_aButtonInfo[$iSize - 1], "hTheme", OpenThemeData ($hWnd, "Button"))
		Endif
	Else
			DllStructSetData ($g_aButtonInfo[$iSize - 1], "hTheme", 0)
	EndIf

	; Assign the window text as specified in the call to CreateWindow
	SetWindowText ($hwnd, DllStructGetData ($cs, "lpszName"))

	; Attach custom structure to this window.
	SetWindowLongPtr ($hWnd, 0, DllStructGetPtr ($g_aButtonInfo[$iSize - 1]))

EndFunc

Func OnDestroy ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $iSize = UBound ($g_aButtonInfo)

	; cleanup ...
	GUICtrlDelete (GetDlgCtrlID (DllStructGetData ($btnInfo, "hWndCtrl")))

	CloseThemeData (DllStructGetData ($btnInfo, "hTheme"))

	DeleteObject (DllStructGetData ($btnInfo, "hBmpNormal"))
	DeleteObject (DllStructGetData ($btnInfo, "hBmpHover"))
	DeleteObject (DllStructGetData ($btnInfo, "hBmpPress"))

	DeleteDC (DllStructGetData ($btnInfo, "hdcMem"))

	$btnInfo = 0

	If ($iSize > 1) Then
		ReDim $g_aButtonInfo [$iSize - 1]
	Else
		$g_aButtonInfo = 0
	EndIf

EndFunc

Func OnGetDlgCode ($lpBtnInfo, $lParam)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $iState = DllStructGetData ($btnInfo, "iState")
	Local $sText
	Local $hwndCtrl
	Local $stMSG
	Local $message
	Local $wParam

	If ($lParam) Then

		$stMSG = DllStructCreate ($MSG, $lParam)
		$hwndCtrl = DllStructGetData ($stMSG, "hwnd")
		$message  = DllStructGetData ($stMSG, "message")
		$wParam   = DllStructGetData ($stMSG, "wParam")

		Switch ($message)

			Case $WM_SYSCHAR

				For $i = 0 To UBound ($g_aButtonInfo) - 1

					GetWindowText ($hwndCtrl, $sText, 256)

					If (StringInStr ($sText, '&'&Chr ($wParam))) Then


					EndIf
				Next

			Case $WM_KEYDOWN

				If ($wParam == $_VK_RETURN) Then

					If ($g_bAccel) Then _
						$g_bAccel = FALSE

					If ($iState <> $PBS_PRESSED) Then
						DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpPress"))
						DllStructSetData ($btnInfo, "iState", $PBS_PRESSED)

						RedrawWindow ($hwndCtrl, _
								    $_NULL, _
								    $_NULL, _
								    $RDW_INVALIDATE)
					EndIf

					GUICtrlSendToDummy (GetDlgCtrlID ($hwndCtrl))

					PostMessage (GetParent ($hwndCtrl), _
								 $WM_COMMAND, _
								 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_CLICKED), _
								 $hWndCtrl)


				ElseIf ($wParam == $_VK_SPACE) Then

					If ($g_bAccel) Then _
						$g_bAccel = FALSE

					If ($iState <> $PBS_PRESSED) Then
						DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpPress"))
						DllStructSetData ($btnInfo, "iState", $PBS_PRESSED)

						RedrawWindow ($hwndCtrl, _
								    $_NULL, _
								    $_NULL, _
								    $RDW_INVALIDATE)

					EndIf
				EndIf

		EndSwitch
	EndIf

	Return BitOR ($_DLGC_WANTMESSAGE, $_DLGC_WANTALLKEYS)

EndFunc

Func OnGetFont ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Return DllStructGetData ($btnInfo, "hFont")

EndFunc

Func OnKeyDown ($lpBtnInfo, $wParam)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")



	If ($wParam == $_VK_RETURN Or _
		$wParam == $_VK_SPACE) Then

		If (DllStructGetData ($btnInfo, "hBmpCurrent") <> _
			DllStructGetData ($btnInfo, "hBmpPress")) Then

			DllStructSetData ($btnInfo, "hBmpCurrent", _
					DllStructGetData ($btnInfo, "hBmpPress"))

			RedrawWindow ($hwndCtrl, _
						  $_NULL, _
						  $_NULL, _
						  $RDW_INVALIDATE)
		EndIf

		If ($wParam == $_VK_RETURN) Then

		GUICtrlSendToDummy (GetDlgCtrlID ($hwndCtrl))

		NotifyParent ($lpBtnInfo, $_BN_CLICKED)
		PostMessage (GetParent ($hwndCtrl), _
					 $WM_COMMAND, _
					 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_CLICKED), _
					 $hWndCtrl)
		EndIf
	EndIf

EndFunc

Func OnKeyUp ($lpBtnInfo, $wParam)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	If ($wParam == $_VK_RETURN Or _
		$wParam == $_VK_SPACE) Then

		If ($g_bAccel) Then _
			$g_bAccel = FALSE

		DllStructSetData ($btnInfo, "hBmpCurrent", _
				DllStructGetData ($btnInfo, "hBmpHover"))

		RedrawWindow ($hwndCtrl, _
					  $_NULL, _
					  $_NULL, _
					  $RDW_INVALIDATE)

		If ($wParam == $_VK_SPACE) Then

		GUICtrlSendToDummy (GetDlgCtrlID ($hwndCtrl))

		NotifyParent ($lpBtnInfo, $_BN_CLICKED)
		PostMessage (GetParent ($hwndCtrl), _
					 $WM_COMMAND, _
					 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_CLICKED), _
					 $hWndCtrl)
		EndIf
	EndIf

EndFunc

Func OnKillFocus ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpNormal"))
	DllStructSetData ($btnInfo, "iState", $PBS_NORMAL)

	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  $RDW_INVALIDATE)

	PostMessage (GetParent ($hwndCtrl), _
				 $WM_COMMAND, _
				 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_KILLFOCUS), _
				 $hwndCtrl)

EndFunc

Func OnLButtonDown ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	SetFocus ($hwndCtrl)

	DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpPress"))
	DllStructSetData ($btnInfo, "iState", $PBS_PRESSED)

	If ($g_bAccel) Then _
		$g_bAccel = FALSE

	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  $RDW_INVALIDATE)

EndFunc

Func OnLButtonUp ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	If (DllStructGetData ($btnInfo, "hBmpCurrent") == _
		DllStructGetData ($btnInfo, "hBmpPress")) Then

		DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpHover"))
		DllStructSetData ($btnInfo, "iState", $PBS_NORMAL)

		RedrawWindow ($hwndCtrl, _
					  $_NULL, _
					  $_NULL, _
					  $RDW_INVALIDATE)

		GUICtrlSendToDummy (GetDlgCtrlID ($hwndCtrl))

		NotifyParent ($lpBtnInfo, $_BN_CLICKED)
		PostMessage (GetParent ($hwndCtrl), _
					 $WM_COMMAND, _
					 MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_CLICKED), _
					 $hwndCtrl)
	EndIf

EndFunc

Func OnMouseHover ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")


	If (DllStructGetData ($btnInfo, "hTheme")) Then

		If (DllStructGetData ($btnInfo, "iState") <> $PBS_HOT) Then
			DllStructSetData ($btnInfo, "iState", $PBS_HOT)

			RedrawWindow ($hwndCtrl, _
					    $_NULL, _
					    $_NULL, _
					    $RDW_INVALIDATE)
		EndIf
		Return 0
	EndIf

	If (DllStructGetData ($btnInfo, "hBmpCurrent") == _
	    DllStructGetData ($btnInfo, "hBmpPress")) Then _
		Return

	If ($g_bMouseHover == FALSE) Then

		$g_bMouseHover = TRUE

		DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpHover"))

		RedrawWindow ($hwndCtrl, _
				    $_NULL, _
				    $_NULL, _
				    $RDW_INVALIDATE)
	EndIf

	Return 0

EndFunc

Func OnMouseLeave ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")


	$g_bMouseHover = FALSE

	If (GetFocus ( ) == $hwndCtrl) Then
		DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpHover"))
		DllStructSetData ($btnInfo, "iState", $PBS_DEFAULTED)
	Else
		DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpNormal"))
		DllStructSetData ($btnInfo, "iState", $PBS_NORMAL)
	EndIf

	RedrawWindow ($hwndCtrl, _
				  $_NULL, _
				  $_NULL, _
				  $RDW_INVALIDATE)

EndFunc

Func OnMouseMove ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $tme     = DllStructCreate ($TRACKMOUSEEVENT)

	DllStructSetData ($tme, "cbSize"     , DllStructGetSize ($tme))
	DllStructSetData ($tme, "dwFlags"    , BitOR ($_TME_HOVER, $_TME_LEAVE))
	DllStructSetData ($tme, "dwHoverTime", 15)
	DllStructSetData ($tme, "hwndTrack"  , DllStructGetData ($btnInfo, "hWndCtrl"))

	TrackMouseEvent (DllStructGetPtr ($tme))

EndFunc

Func OnPaint ($lpBtnInfo)

	Local $btnInfo  = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $ps       = DllStructCreate ($PAINTSTRUCT)
	Local $bmp      = DllStructCreate ($BITMAP)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")
	Local $hdcMem, $hdc
	Local $hbmpOld, $hbmp = DllStructGetData ($btnInfo, "hbmpCurrent")
	Local $dwColor = DllStructGetData ($btnInfo, "crText")
	Local $r = GetRValue ($dwColor)
	Local $g = GetGValue ($dwColor)
	Local $b = GetBValue ($dwColor)
	Local $hfontOld
	Local $sText
	Local $hTheme
	Local $iState
	Local $uFormat

	; Get a device context for this window
	$hdc = BeginPaint ($hwndCtrl, DllStructGetPtr ($ps))

	$hTheme = DllStructGetData ($btnInfo, "hTheme")

	If ($hTheme) Then

		$iState = DllStructGetData ($btnInfo, "iState")

		DrawThemeBackground ($hTheme, $hdc, $BP_PUSHBUTTON, _
					$iState, DllStructGetPtr ($ps, "rcPaint"), 0)

		If ($iState == $PBS_DEFAULTED) Then
			InflateRect (DllStructGetPtr ($ps, "rcPaint"), -3, -3)
			DrawFocusRect ($hdc, DllStructGetPtr ($ps, "rcPaint"))
		EndIf

	Else

		; Select the bitmap into the memory DC
		$hbmpOld = SelectObject ($g_hdcMem, $hbmp)

		; Get the bitmap dimensions
		GetObject ($hbmp, DllStructGetSize ($bmp), DllStructGetPtr ($bmp))

		; Blit the memory DC into the window DC
		StretchBlt ($hdc, 0, 0, _
				  DllStructGetData ($ps, "rcPaint", 3), _
				  DllStructGetData ($ps, "rcPaint", 4), _
				  $g_hdcMem, 0, 0, _
				  DllStructGetData ($bmp, "bmWidth"), _
				  DllStructGetData ($bmp, "bmHeight"), _
				  $SRCCOPY)

		; Restore the old bitmap when we have finished
		SelectObject ($g_hdcMem, $hbmpOld)

	EndIf

	; Set the font we are going to use
	$hfontOld = SelectObject ($hdc, DllStructGetData ($btnInfo, "hFont"))

	; Set the text colours
	SetTextColor ($hdc, RGB($r, $g, $b))
	SetBkMode ($hdc, $TRANSPARENT)

	; Find the text to draw
	GetWindowText ($hwndCtrl, $sText, 256)

	$uFormat = BitOR ($DT_SINGLELINE, $DT_CENTER, $DT_VCENTER)

	If (not $g_bAccel) Then _
		$uFormat = BitOR ($uFormat, $DT_HIDEPREFIX)

	; Draw the text
	DrawText ($hdc, $sText, StringLen ($sText), _
			DllStructGetPtr ($ps, "rcPaint"), _
			$uFormat)

	; Restore the old font when we have finished
	SelectObject ($hdc, $hfontOld)

	; Release the device context
	EndPaint ($hwndCtrl, DllStructGetPtr ($ps))

EndFunc

Func OnSetFocus ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	DllStructSetData ($btnInfo, "hBmpCurrent", DllStructGetData ($btnInfo, "hBmpHover"))
	DllStructSetData ($btnInfo, "iState", $PBS_DEFAULTED)

	RedrawWindow ( _
		$hwndCtrl, _
		$_NULL, _
		$_NULL, _
		$RDW_INVALIDATE _
		)

	PostMessage ( _
		GetParent ($hwndCtrl), _
		$WM_COMMAND, _
		MAKEWPARAM(GetDlgCtrlID ($hwndCtrl), $_BN_SETFOCUS), _
		$hwndCtrl _
		)

EndFunc

Func OnSetFont ($lpBtnInfo, $wParam)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	DllStructSetData ($btnInfo, "hFont", $wParam)

EndFunc

Func OnSysKeyDown ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl

	If ($g_bSysKeyDown) Then _
		Return

	If (not $g_bAccel) Then
		$g_bAccel = TRUE
	Else
		$g_bAccel = FALSE
	EndIf

	For $i = 0 To UBound ($g_aButtonInfo) - 1

		$hwndCtrl = DllStructGetData ($g_aButtonInfo[$i], "hWndCtrl")

		RedrawWindow ($hwndCtrl, _
				    $_NULL, _
				    $_NULL, _
				    $RDW_INVALIDATE)
	Next

	$g_bSysKeyDown = TRUE

	Return

EndFunc

Func OnSysKeyUp ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hwndCtrl

	If ($g_bSysKeyDown) Then _
		$g_bSysKeyDown = FALSE

	Return

EndFunc

Func OnThemeChanged ($lpBtnInfo)

	Local $btnInfo = DllStructCreate ($BUTTONCTRL, $lpBtnInfo)
	Local $hTheme   = DllStructGetData ($btnInfo, "hTheme")
	Local $hwndCtrl = DllStructGetData ($btnInfo, "hWndCtrl")

	If ($hTheme) Then

		CloseThemeData ($hTheme)
		DllStructSetData ($btnInfo, "hTheme", OpenThemeData ($hwndCtrl, "Button"))
	EndIf

EndFunc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                Exit Function                 ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Func OnEzBmpButtonExit ( )

	DeleteDC ($g_hdcMem)

	DllCallbackFree ($g_hButtonProc)

	DllClose ($gdi32dll)
	DllClose ($user32dll)
	DllClose ($shell32dll)
	DllClose ($kernel32dll)
	DllClose ($msimg32dll)
	DllClose ($uxthemedll)

EndFunc



;~~~~~~~~~~~~~~~~~~~~~~  API Functions  ~~~~~~~~~~~~~~~~~~~~~~

Func BeginPaint ($hWnd, $lpPaint)

	Local $aRes = DllCall ($user32dll, "hwnd", "BeginPaint", _
											"hwnd", $hWnd, _
											"ptr", $lpPaint)
	If @error Then _
		Return @error

	Return $aRes[0]


EndFunc

Func CreateCompatibleDC ($hdc)

	Local $aRes = DllCall ($gdi32dll, 'HANDLE', 'CreateCompatibleDC', _
								'HANDLE', $hdc)   ; handle to DC
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func CreateWindowEx ($dwExStyle, $sClassName, $sWindowName, $dwStyle, $x, $y, $nWidth, $nHeight, $hWndParent, $hMenu, $hInstance, $lpParam)

	Local $aRes = DllCall ($user32dll, 'hwnd', 'CreateWindowExW', _
								'dword', $dwExStyle, _
								'wstr' , $sClassName, _
								'wstr' , $sWindowName, _
								'dword', $dwStyle, _
								'int'  , $x, _
								'int'  , $y, _
								'int'  , $nWidth, _
								'int'  , $nHeight, _
								'hwnd' , $hWndParent, _
								'ptr'  , $hMenu, _
								'ptr'  , $hInstance, _
								'ptr'  , $lpParam)
	Return $aRes[0]

EndFunc

Func DefWindowProc ($hWnd, $nMsg, $wParam, $lParam)

	Local $aRes
	$aRes = DllCall ($user32dll, "LRESULT", "DefWindowProcW", _
							"HWND", $hWnd, _
							"UINT", $nMsg, _
							"WPARAM", $wParam, _
							"LPARAM", $lParam)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func DeleteDC ($hdc)

	Local $aRes = DllCall ($gdi32dll, 'int', 'DeleteDC', _
								'HANDLE', $hdc)   ; handle to DC
	Return $aRes[0]

EndFunc

Func DeleteObject ($hObject)

	Local $aRes = DllCall ($gdi32dll, 'int', 'DeleteObject', _
								'HANDLE', $hObject)   ; handle to graphic object
	Return $aRes[0]

EndFunc

Func DrawFocusRect ($hDC, $lprc)

	Local $aRes = DllCall ($user32dll, 'int', 'DrawFocusRect', _
								'HANDLE', $hDC, _  ; handle to device context
								'ptr', $lprc)   ; logical coordinates
	Return $aRes[0]

EndFunc

Func DrawText ($hDC, $lpString, $nCount, $lpRect, $uFormat)

	Local $type = "wstr"

	If (IsPtr ($lpString)) Then _
		$type = "ptr"

	Local $aRes = DllCall ($user32dll, "int", "DrawTextW", _
								"HANDLE",  $hDC, _
								$type,  $lpString, _
								"int",  $nCount, _
								"ptr",  $lpRect, _
								"UINT", $uFormat)
	Return $aRes[0]

EndFunc

Func EndPaint ($hWnd, $lpPaint)

	Local $aRes = DllCall ($user32dll, "int", "EndPaint", _
								"HWND", $hWnd, _
								"ptr", $lpPaint)
	Return $aRes[0]

EndFunc

Func GetDlgCtrlID ($hwndCtl)

	Local $aRes = DllCall ($user32dll, 'int', 'GetDlgCtrlID', _
								'HWND', $hwndCtl)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetDlgItem ($hDlg, $nIDDlgItem)

	Local $aRes = DllCall ($user32dll, 'HWND', 'GetDlgItem', _
								'HWND', $hDlg, _
								'int' , $nIDDlgItem)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetFocus ( )

	Local $aRes = DllCall ($user32dll, 'HWND', 'GetFocus')
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetModuleHandle ($sModuleName)

	Local $type = 'wstr'
	If (IsPtr ($sModuleName)) Then $type = 'HANDLE'
	Local $aRes = DllCall ($kernel32dll, "HANDLE", "GetModuleHandleW", _
									$type, $sModuleName)
	Return $aRes[0]

EndFunc

Func GetObject ($hgdiobj, $cbBuffer, $lpvObject)

	Local $aRes = DllCall ($gdi32dll, 'int', 'GetObject', _
								'HANDLE', $hgdiobj, _  ; handle to graphics object
								'int', $cbBuffer, _     ; size of buffer for object information
								'ptr', $lpvObject)  ; buffer for object information
	Return $aRes[0]

EndFunc

Func GetParent ($hWnd)

	Local $aRes = DllCall ($user32dll, 'HWND', 'GetParent', _
								'HWND', $hWnd)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetStockObject ($iObject)

	Local $aRes = DllCall ($gdi32dll, "hwnd", "GetStockObject", "int", $iObject)

	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetWindowLongPtr ($hWnd, $nIndex)

	If (@AutoItX64) Then
		Local $aRes = DllCall ($user32dll, "LONG_PTR", "GetWindowLongPtrW", _
									"HWND", $hWnd, _
									"int" , $nIndex)
	Else
		Local $aRes = DllCall ($user32dll, "LONG", "GetWindowLongW", _
									"HWND", $hWnd, _
									"int" , $nIndex)
	EndIf

	Return $aRes[0]

EndFunc

Func GetWindowText ($hWnd, ByRef $sString, $nMaxCount)


	Local $type = 'wstr'
	If (IsPtr ($sString)) Then _
		$type = 'ptr'

	Local $aRes = DllCall ($user32dll, 'int', 'GetWindowTextW', _
								'HWND', $hWnd, _
								$type , $sString, _
								'int' , $nMaxCount)

	If @error Then _
		Return @error

	If (not IsPtr ($sString)) Then _
		$sString = $aRes[2]
	Return $aRes[0]

EndFunc

Func InflateRect ($lprc, $dx, $dy)

	Local $aRes = DllCall ($user32dll, 'int', 'InflateRect', _
								'ptr', $lprc, _  ; rectangle
								'int', $dx, _    ; amount to adjust width
								'int', $dy)      ; amount to adjust height
	Return $aRes[0]

EndFunc

Func LoadCursor ($hInstance, $sCursorName)

	Local $type = "wstr"

	If (IsPtr ($sCursorName)) Then _
		$type = "ptr"

	Local $aRes = DllCall ($user32dll, "HANDLE", "LoadCursorW", _
								"HANDLE", $hInstance, _
								$type, $sCursorName)
	Return $aRes[0]

EndFunc

Func LoadIcon ($hInstance, $sIconName)

	Local $type = "wstr"

	If (IsPtr ($sIconName)) Then _
		$type = "ptr"

	Local $aRes = DllCall ($user32dll, "HANDLE", "LoadIconW", _
								"HANDLE", $hInstance, _
								$type, $sIconName)
	Return $aRes[0]

EndFunc

Func LoadImage ($hinst, $lpszName, $uType, $cxDesired, $cyDesired, $fuLoad)

	Local $type = "wstr"

	If (IsPtr ($lpszName)) Then _
		$type = "ptr"

	Local $aRes = DllCall ($user32dll, 'HANDLE', 'LoadImageW', _
								'HANDLE' , $hinst, _
								$type , $lpszName, _
								'UINT', $uType, _
								'int' , $cxDesired, _
								'int' , $cyDesired, _
								'UINT', $fuLoad)
;~ DebugDllCall ($aRes, "LoadImage")
	Return $aRes[0]

EndFunc

Func PostMessage ($hWnd, $Msg, $wParam, $lParam)

	Local $aRes = DllCall ($user32dll, 'int', 'PostMessageW', _
								'HWND'  , $hWnd, _
								'UINT'  , $Msg, _
								'WPARAM', $wParam, _
								'LPARAM', $lParam)
	Return $aRes[0]

EndFunc

Func RedrawWindow ($hWnd, $lprcUpdate, $hrgnUpdate, $flags)

	Local $aRes = DllCall ($user32dll, 'int', 'RedrawWindow', _
								'HWND', $hWnd, _               ; handle to window
								'ptr' , $lprcUpdate, _         ; update rectangle
								'HANDLE' , $hrgnUpdate, _         ; handle to update region
								'UINT', $flags)                ; array of redraw flags
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func RegisterClassEx ($lpwcx)

	Local $aRes = DllCall ($user32dll, "DWORD", "RegisterClassExW", _
								"ptr", $lpwcx)
	Return $aRes[0]

EndFunc

Func SelectObject ($hdc, $hgdiobj)

	Local $aRes = DllCall ($gdi32dll, 'HANDLE', 'SelectObject', _
								'HANDLE', $hdc, _          ; handle to DC
								'HANDLE', $hgdiobj)        ; handle to object
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SendMessage ($hWnd, $Msg, $wParam, $lParam)

	Local $aRes = DllCall ($user32dll, 'ULONG', 'SendMessageW', _
								'HWND'  , $hWnd, _
								'UINT'  , $Msg, _
								'WPARAM', $wParam, _
								'LPARAM', $lParam)
	Return $aRes[0]

EndFunc

Func SetBkMode ($hdc, $iBkMode)

	Local $aRes = DllCall ($gdi32dll, 'int', 'SetBkMode', _
								'HANDLE', $hdc, _      ; handle to DC
								'int', $iBkMode)    ; background mode
	Return $aRes[0]

EndFunc

Func SetFocus ($hWnd)

	Local $aRes = DllCall ($user32dll, 'HWND', 'SetFocus', _
								'HWND', $hWnd)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SetTextColor ($hdc, $crColor)

	Local $aRes = DllCall ($gdi32dll, 'DWORD', 'SetTextColor', _
								'ptr'  , $hdc, _           ; handle to DC
								'DWORD', $crColor)         ; text color
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func SetWindowLongPtr ($hWnd, $nIndex, $dwNewLong)

	If (@AutoItX64) Then
		Local $aRes = DllCall ($user32dll, "LONG_PTR", "SetWindowLongPtrW", _
									"HWND", $hWnd, _
									"int" , $nIndex, _
									"LONG_PTR", $dwNewLong)
	Else
		Local $aRes = DllCall ($user32dll, "LONG", "SetWindowLongW", _
									"HWND", $hWnd, _
									"int" , $nIndex, _
									"LONG", $dwNewLong)
	EndIf

	Return $aRes[0]

EndFunc

Func SetWindowText ($hWnd, $sString)

	Local $type = 'wstr'
	If (IsPtr ($sString)) Then _
		$type = 'ptr'

	Local $aRes = DllCall ($user32dll, 'int', 'SetWindowTextW', _
								'HWND', $hWnd, _
								$type , $sString)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func StretchBlt ($hdcDest, $nXOriginDest, $nYOriginDest, $nWidthDest, $nHeightDest, _
			  $hdcSrc, $nXOriginSrc, $nYOriginSrc, $nWidthSrc, $nHeightSrc, $dwRop)

	Local $aRes = DllCall ($gdi32dll, 'int', 'StretchBlt', _
								'HANDLE', $hdcDest, _      ; handle to destination DC
								'int', $nXOriginDest, _ ; x-coord of destination upper-left corner
								'int', $nYOriginDest, _ ; y-coord of destination upper-left corner
								'int', $nWidthDest, _   ; width of destination rectangle
								'int', $nHeightDest, _  ; height of destination rectangle
								'HANDLE', $hdcSrc, _       ; handle to source DC
								'int', $nXOriginSrc, _  ; x-coord of source upper-left corner
								'int', $nYOriginSrc, _  ; y-coord of source upper-left corner
								'int', $nWidthSrc, _    ; width of source rectangle
								'int', $nHeightSrc, _   ; height of source rectangle
								'DWORD', $dwRop)        ; raster operation code
	Return $aRes[0]

EndFunc

Func TransparentBlt ($hdcDest, $nXOriginDest, $nYOriginDest, $nWidthDest, $hHeightDest, _
				 $hdcSrc, $nXOriginSrc, $nYOriginSrc, $nWidthSrc, $nHeightSrc, $crTransparent)

	Local $aRes = DllCall ($msimg32dll, 'int', 'TransparentBlt', _
								'HANDLE', $hdcDest, _        ; handle to destination DC
								'int', $nXOriginDest, _   ; x-coord of destination upper-left corner
								'int', $nYOriginDest, _   ; y-coord of destination upper-left corner
								'int', $nWidthDest, _     ; width of destination rectangle
								'int', $hHeightDest, _    ; height of destination rectangle
								'HANDLE', $hdcSrc, _         ; handle to source DC
								'int', $nXOriginSrc, _    ; x-coord of source upper-left corner
								'int', $nYOriginSrc, _    ; y-coord of source upper-left corner
								'int', $nWidthSrc, _      ; width of source rectangle
								'int', $nHeightSrc, _     ; height of source rectangle
								'UINT', $crTransparent)   ; color to make transparent
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func TrackMouseEvent ($lpEventTrack)

	Local $aRes = DllCall ($user32dll, 'int', 'TrackMouseEvent', _
								'ptr', $lpEventTrack)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc


;

Func CloseThemeData ($hTheme)

	Local $aRes = DllCall ($uxthemedll, 'long', 'CloseThemeData', _
								'ptr', $hTheme)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func IsAppThemed ( )

	Local $aRes = DllCall ($uxthemedll, 'int', 'IsAppThemed')
	Return $aRes[0]

EndFunc

Func OpenThemeData ($hwnd, $pszClassList)

	Local $aRes = DllCall ($uxthemedll, 'ptr', 'OpenThemeData', _
										'hwnd', $hwnd, _
										'wstr', $pszClassList)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func DrawThemeBackground ($hTheme, $hdc, $iPartId, $iStateId, $pRect, $pClipRect)

	Local $aRes = DllCall ($uxthemedll, 'long', 'DrawThemeBackground', _
										'ptr', $hTheme, _
										'ptr', $hdc, _
										'int', $iPartId, _
										'int', $iStateId, _
										'ptr', $pRect, _
										'ptr', $pClipRect)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func DrawThemeEdge ($hTheme, $hdc, $iPartId, $iStateId, $pDestRect, $uEdge, $uFlags, $pContentRect)

	Local $aRes = DllCall ($uxthemedll, 'long', 'DrawThemeEdge', _
										'ptr', $hTheme, _
										'ptr', $hdc, _
										'int', $iPartId, _
										'int', $iStateId, _
										'ptr', $pDestRect, _
										'uint', $uEdge, _
										'uint', $uFlags, _
										'ptr', $pContentRect)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func DrawThemeText ($hTheme, $hdc, $iPartId, $iStateId, $pszText, $iCharCount, $dwTextFlags, $dwTextFlags2, $pRect)

	Local $aRes = DllCall ($uxthemedll, 'long', 'DrawThemeText', _
										'ptr',   $hTheme, _
										'ptr',   $hdc, _
										'int',   $iPartId, _
										'int',   $iStateId, _
										'wstr',  $pszText, _
										'int',   $iCharCount, _
										'dword', $dwTextFlags, _
										'dword', $dwTextFlags2, _
										'ptr',   $pRect)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc

Func GetThemeBackgroundContentRect ($hTheme, $hdc, $iPartId, $iStateId, $pBoundingRect, $pContentRect)

	Local $aRes = DllCall ($uxthemedll, 'long', 'GetThemeBackgroundContentRect', _
										'ptr', $hTheme, _
										'ptr', $hdc, _
										'int', $iPartId, _
										'int', $iStateId, _
										'ptr', $pBoundingRect, _
										'ptr', $pContentRect)
	If @error Then _
		Return @error

	Return $aRes[0]

EndFunc



;~~~~~~~~~~~~~~~~~~~~~~  Macros  ~~~~~~~~~~~~~~~~~~~~~~

Func IS_INTRESOURCE($wInteger)
	Return (not BitShift ($wInteger, 16))
EndFunc

Func LOWORD($DWORD)
	Return BitAND($DWORD, 0xFFFF)
EndFunc

Func HIWORD($DWORD)
	Return BitShift($DWORD, 16)
EndFunc

Func LOBYTE($w)
	Return BitAND ( $w, 0xFF )
EndFunc

Func HIBYTE($w)
	Return BitAND ( BitShift ( $w, 8 ), 0xFF )
EndFunc

Func MAKEINTRESOURCE ($wInteger)
	Return Ptr ($wInteger)
EndFunc

Func MAKELONG($wLow, $wHigh)
	Return BitOR ( BitAND ( $wLow, 0xFFFF ), BitShift (BitAND ( $wHigh, 0xFFFF ), -16) )
EndFunc

Func MAKEWPARAM($wLow, $wHigh)
	Return BitOR ( BitAND ( $wLow, 0xFFFF ), BitShift (BitAND ( $wHigh, 0xFFFF ), -16) )
EndFunc

Func RGB($r, $g, $b)
	Return BitOR ( $r, BitShift ($g, -8), BitShift ($b, -16)) ; COLORREF / BGR
EndFunc

Func GetRValue ($rgb)
	Return LOBYTE ( $rgb )
EndFunc

Func GetGValue ($rgb)
	Return LOBYTE ( BitShift ( $rgb, 8 ) )
EndFunc

Func GetBValue ($rgb)
	Return LOBYTE ( BitShift ( $rgb, 16 ) )
EndFunc
