#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_outfile=EzBmpButtonDemo.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Run_After=%scitedir%\AutoIt3Wrapper\ResHacker.exe -script .\bitmaps.rhs
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****


#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>

#include "EzBmpButton.au3"

; Konstanten fr Ressourcen-Identifizierer
Global Enum $IDB_BTN_1 = 100, _
			$IDB_BTN_2, _
			$IDB_BTN_3, _
			$IDB_BTN_4 = 110, _
			$IDB_BTN_5, _
			$IDB_BTN_6, _
			$IDB_BTN_7 = 120, _
			$IDB_BTN_8


Global $ID_BUTTON_1, $ID_BUTTON_2, $ID_BUTTON_3, $ID_BUTTON_4, $ID_BUTTON_5

Global $hButton1, $hButton2, $hButton3, $hButton4

ConsoleWrite (StringFormat ("-> ### Beginn - Bitmap Button Demo ! ###\n"))

If (@Compiled) Then
	Exit (ExampleRes ( ))
Else
	Exit (ExampleDir ( ))
EndIf

Func ExampleDir ( )

	Local $hwndTest, $iMsg


	; Create the main window
	$hwndTest = GUICreate ( _
				"Bitmap Button Test", _
				600, 480, -1, -1, _
				$WS_OVERLAPPEDWINDOW, _
				$WS_EX_CLIENTEDGE _
				)

	; Create some EzBmpButtons ...

	$ID_BUTTON_1 = CreateEzBmpButton ( _
					"", _                      ; Text
					20, 30, 100, 30, _         ; Position/size
					$hwndTest, _               ; Parent window
					'.\Normal_1.bmp', _        ; Default state bitmap
					'.\Hover_1.bmp', _         ; Hover state bitmap
					'.\Press_1.bmp' _          ; Pressed state bitmap
					)

	$ID_BUTTON_2 = CreateEzBmpButton ( _
					"", _
					20, 80, 100, 30, _
					$hwndTest, _
					'.\Normal_2.bmp', _
					'.\Hover_2.bmp', _
					'.\Press_2.bmp' _
					)

	$ID_BUTTON_3 = CreateEzBmpButton ( _
					"Button &3", _        ; Text
					20, 130, 100, 30, _   ; Position/size
					$hwndTest, _          ; Parent window
					'.\Normal.bmp', _     ; Default state bitmap
					'.\Hover.bmp', _      ; Hover state bitmap
					'.\Hover.bmp', _      ; Pressed state bitmap
					0x00FF00 _            ; Text colour
					)

	$ID_BUTTON_4 = CreateEzBmpButton ( _
					"Button &4", _
					20, 180, 100, 30, _
					$hwndTest, _
					'.\Normalx.bmp', _	; Bitmap doesn't exist !
					'.\Hoverx.bmp', _	; Bitmap doesn't exist !
					'.\Hoverx.bmp', _	; Bitmap doesn't exist !
					0x0000FF _ ; red text
					)

	; Create a common windows button
	$ID_BUTTON_5 = GUICtrlCreateButton ( _
					"Button &5", _
					20, 250, 100, 30, _
					BitOR ($WS_CHILD, $WS_VISIBLE, $WS_TABSTOP, $WS_CLIPSIBLINGS, $BS_NOTIFY) _
					)

	$hButton4    = GUICtrlGetHandle ($ID_BUTTON_4)

	GUICtrlCreateGroup (" EzBmpButton ", 10, 10, 130, 210)
	GUICtrlCreateGroup ("", -99, -99, 1, 1)

	GUICtrlCreateGroup (" Standard Button ", 10, 230, 130, 60)
	GUICtrlCreateGroup ("", -99, -99, 1, 1)

;~ 	GUIRegisterMsg ($WM_COMMAND   , "WM_COMMAND")
;~ 	GUIRegisterMsg ($WM_NOTIFY    , "WM_NOTIFY")

	GUISetState (@SW_SHOW, $hwndTest)

	While (True)

		$iMsg = GUIGetMsg (False)

		Switch ($iMsg)
			Case $GUI_EVENT_CLOSE
				GUIDelete ($hwndTest)
				ExitLoop

			Case $ID_BUTTON_1 To $ID_BUTTON_5
				MsgBox (270400, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))

		EndSwitch
	WEnd

EndFunc

Func ExampleRes ( )

	Local $hwndTest, $iMsg


	; Create the main window
	$hwndTest = GUICreate ( _
				"Bitmap Button Test", _
				600, 480, -1, -1, _
				$WS_OVERLAPPEDWINDOW, _
				$WS_EX_CLIENTEDGE _
				)

	; Create some EzBmpButtons ...

	$ID_BUTTON_1 = CreateEzBmpButton ( _
					"", _                  ; Text
					20, 30, 100, 30, _     ; Position/size
					$hwndTest, _           ; Parent window
					$IDB_BTN_1, _          ; Default state bitmap
					$IDB_BTN_2, _          ; Hover state bitmap
					$IDB_BTN_3 _           ; Presed state bitmap
					)

	$ID_BUTTON_2 = CreateEzBmpButton ( _
					"", _
					20, 80, 100, 30, _
					$hwndTest, _
					$IDB_BTN_4, _
					$IDB_BTN_5, _
					$IDB_BTN_6 _
					)

	$ID_BUTTON_3 = CreateEzBmpButton ( _
					"Button &3", _
					20, 130, 100, 30, _
					$hwndTest, _
					$IDB_BTN_7, _
					$IDB_BTN_8, _
					$IDB_BTN_8, _
					0x00FF00 _ ; green text
					)

	$ID_BUTTON_4 = CreateEzBmpButton ( _
					"Button &4", _
					20, 180, 100, 30, _
					$hwndTest, _
					0, _	; Bitmap doesn't exist !
					0, _	; Bitmap doesn't exist !
					0, _	; Bitmap doesn't exist !
					0x0000FF _ ; red text
					)

	; Create a common windows button
	$ID_BUTTON_5 = GUICtrlCreateButton ( _
					"Button 4", _
					20, 250, 100, 30, _
					BitOR ($WS_CHILD, $WS_VISIBLE, $WS_TABSTOP, $WS_CLIPSIBLINGS, $BS_NOTIFY) _
					)

	$hButton4    = GUICtrlGetHandle ($ID_BUTTON_4)


	GUICtrlCreateGroup (" EzBmpButton ", 10, 10, 130, 210)
	GUICtrlCreateGroup ("", -99, -99, 1, 1)

	GUICtrlCreateGroup (" Standard Button ", 10, 230, 130, 60)
	GUICtrlCreateGroup ("", -99, -99, 1, 1)

;~ 	GUIRegisterMsg ($WM_COMMAND   , "WM_COMMAND")
;~ 	GUIRegisterMsg ($WM_NOTIFY    , "WM_NOTIFY")

	GUISetState (@SW_SHOW, $hwndTest)

	While (True)

		$iMsg = GUIGetMsg ( )

		Switch ($iMsg)
			Case $GUI_EVENT_CLOSE
				GUIDelete ($hwndTest)
				 ExitLoop

			Case $ID_BUTTON_1 To $ID_BUTTON_5
				MsgBox (270400, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))

			Case Else
				ContinueLoop
		EndSwitch
	WEnd

EndFunc

ConsoleWrite (StringFormat ("->  ### Ende - Bitmap Button Demo ! ###\n"))


Func WM_COMMAND ($hWnd, $uMsg, $wParam, $lParam)

	ConsoleWrite (">WM_COMMAND ("&$hWnd&", "&$uMsg&", "&$wParam&", "&$lParam&")" & @crlf)
;~ 	ConsoleWrite ("+>LOWORD(wParam) : "&LOWORD($wParam) & @crlf)
;~ 	ConsoleWrite ("+>HIWORD(wParam) : "&HIWORD($wParam) & @crlf)

	Switch (LOWORD($wParam))
		Case $ID_BUTTON_1
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf
			 EndIf
		Case $ID_BUTTON_2
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf
			 EndIf
		Case $ID_BUTTON_3
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf
			 EndIf
		Case $ID_BUTTON_4
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf
			 EndIf
	EndSwitch

	Return $GUI_RUNDEFMSG

EndFunc

Func WM_NOTIFY ($hWnd, $uMsg, $wParam, $lParam)

	ConsoleWrite ("+>WM_NOTIFY ("&$hWnd&", "&$uMsg&", "&$wParam&", "&$lParam&")" & @crlf)

	Local $nmh = DllStructCreate ($NMHDR, $lParam)
	Local $code, $idFrom, $hwndFrom

	$code     = DllStructGetData ($nmh, "code")
	$idFrom   = DllStructGetData ($nmh, "idFrom")
	$hwndFrom = DllStructGetData ($nmh, "hwndFrom")

	Switch ($hwndFrom)

		Case $hButton1
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)

		Case $hButton2
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)

		Case $hButton3
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)

		Case $hButton4
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)

	EndSwitch

	Return 0

EndFunc


























